<?

$HTTP_HEADER = false;
$HTML_HEADER = false;
$HTML_FOOTER = false;
$GZCOMPRESS = false;

$SOAP_NAMESPACE = $CN_SOAP_SERVER_URI.'?wsdl';


$server = new soap_server();
$server->configureWSDL('Gentics Content.Node(R) SOAP Service',$SOAP_NAMESPACE,$CN_SOAP_SERVER_URI);

$server->wsdl->schemaTargetNamespace = $SOAP_NAMESPACE;






































$server->register(
 'getPublishedPage',
 array('pageId'=>'xsd:int','versionDate'=>'xsd:String'),
 array('contentXML'=>'xsd:string'),
 $CN_SOAP_SERVER_URI,
 $CN_SOAP_SERVER_URI);
$server->register(
 'getTagStruct',
 array('Type'=>'xsd:string', 'tagId'=>'xsd:int'),
 array('contentXML'=>'xsd:string'),
 $CN_SOAP_SERVER_URI,
 $CN_SOAP_SERVER_URI);
$server->register(
 'getPageStruct',
 array('pageId'=>'xsd:int'),
 array('contentXML'=>'xsd:string'),
 $CN_SOAP_SERVER_URI,
 $CN_SOAP_SERVER_URI);



$HTTP_RAW_POST_DATA = isset($HTTP_RAW_POST_DATA) ? $HTTP_RAW_POST_DATA : '';
$server->service($HTTP_RAW_POST_DATA);


function getPublishedPage($pageId, $versionDate) {

 node_include('dbdate');
 node_include('datestring2ts');

 $versionTimestamp = datestring2ts($versionDate);
 $pageId = (int)$pageId;
 if (!$pageId) {
 return new soap_fault('Client','','You must supply a valid pageId.');
 }
 if (!$versionTimestamp) {
 $where = 'AND active = 1';
 } else {
 $where = 'AND pdate  = 1';
 $where = "AND pdate < ".sqlf_value($versionTimestamp)." ORDER BY pdate DESC LIMIT 1";
 }
 $sql = "SELECT * FROM publish WHERE page_id = ".sqlf_tl_num($pageId)." $where ";
 $rs = query( $sql, true);




 if ($rs['num'] > 0) {
 $v = $rs['arr'][0];
 $ret = '<page>';
 $ret .= '<filename>'.$v['filename'].'</filename>';
 $ret .= '<publishtimestamp>'.$v['pdate'].'</publishtimestamp>';
 $ret .= '<publishdate>'.strftime('%c',$v['pdate']).'</publishdate>';
 $ret .= '<source><![CDATA['.$v['source'].']]></source>';
 $ret .= '</page>';
 return new soapval('contentXML','string',$ret);
 } else {
 return new soap_fault('Client','','No page found.');
 }
 
}

function getTagStruct($Type, $tagId){
 
 node_include('get_info');
 node_include('utilities');
 node_include('collections');
 node_include('contentobject');

 
 if(!($Type == 'content' || $Type == 'template' || $Type == 'obj' || $Type == 'global')){
 return new soap_fault('Client','','You must supply a valid Type [content|template|obj|global].');
 }
 $tagId = (int)$tagId;
 if (!$tagId) {
 return new soap_fault('Client','','You must supply a valid tagId.');
 }

 $o_tag = new CNTagObject($Type, $tagId);
 $ret = $o_tag->getXML();
 
 return new soapval('contentXML','string',$ret);
}

function getPageStruct($pageId){

 node_include('get_info');
 node_include('utilities');
 node_include('collections');
 node_include('contentobject');

 $pageId = (int)$pageId;
 if (!$pageId) {
 return new soap_fault('Client','','You must supply a valid pageId.');
 }

 $o_page = new CNPageObject($pageId);
 $ret = "<![CDATA[".$o_page->getXML()."]]>";
 
 return new soapval('contentXML','string',$ret);
}



?>
