<?
GUIFactory::setMainGUI( "shell" );

if( $DEBUG['echo'] ) echo "Starting background job with cmd $cmd ".date('Y-md H:i:s');

if ($cmd == "purgeversions") {
 






 $t = $TIME - months2secs($CN_VERSIONAGE);
 node_class("codeparser");
 
 $javaParser =& CodeParser::getJavaParser();

 
 $javaParser->getPurgeVersionsInfo();
 $running = ($JAVAPARSER_RETURN["params"]["Running"][0] == "true");

 if ($running) {
 
 echo "purge versions job is already running!\n";
 die(1);
 } else {
 
 $code = $javaParser->startPurgeVersions($t);

 
 $running = true;
 $error = false;
 while ($running) {
 
 query("SELECT 1"); 
 if ($javaParser->getPurgeVersionsInfo() === false) {
 
 $returnCode = -1;
 $running = false;
 $error = true;
 } else {
 $running = ($JAVAPARSER_RETURN["params"]["Running"][0] == "true");
 
 if ($running) {
 sleep(10);
 }
 }
 }

 
 if (!$error) {
 
 $returnCode = $JAVAPARSER_RETURN["params"]["ReturnCode"][0];
 }
 $messages = $JAVAPARSER_RETURN["messages"];

 if( $DEBUG['echo'] ) echo "\n\n";
 
 foreach ($messages as $msg) {
 $level = $msg["level"];
 if ($level == "ERROR") {
 echo $level.": ".$msg["code"]."\n";
 }
 }

 
 if ($returnCode != 0) {
 die(1);
 }
 }

} else if($cmd == "node_copy") {
 $lines = array();
 $retval = cmd_node_copy($lines);

 foreach ($lines as $line) {
 echo $line."\n";
 }

 
 if ($retval != 0) {
 die(1);
 }
} else if($cmd == "purgelogs") {
 if( $CN_KEEPLOGS < 1 ) halt(7, "CN_KEEPLOGS is not defined or too small. $CN_KEEPLOGS" );
 if( $CN_KEEPLOGS_LOGCMD && $CN_KEEPLOGS_LOGCMD < 1) halt(7, "CN_KEEPLOGS_LOGCMD is too small. $CN_KEEPLOGS_LOGCMD" );
 if( $CN_KEEPLOGS_LOGERROR && $CN_KEEPLOGS_LOGERROR < 1) halt(7, "CN_KEEPLOGS_LOGERROR is too small. $CN_KEEPLOGS_LOGERROR" );
 if( $CN_KEEPLOGS_JOBRUN && $CN_KEEPLOGS_JOBRUN < 1) halt(7, "CN_KEEPLOGS_JOBRUN is too small. $CN_KEEPLOGS_JOBRUN" );

 
 $t_cmd = $TIME - months2secs( $CN_KEEPLOGS_LOGCMD ? $CN_KEEPLOGS_LOGCMD : $CN_KEEPLOGS );
 $sql = "DELETE FROM logcmd WHERE timestamp < '".sqlf_escaped($t_cmd)."'";
 $rs = query( $sql );
 $logcmdnum = $rs['num'];

 
 $t_err = $TIME - months2secs( $CN_KEEPLOGS_LOGERROR ? $CN_KEEPLOGS_LOGERROR : $CN_KEEPLOGS );
 $sql = "DELETE FROM logerror WHERE timestamp < '".sqlf_escaped($t_err)."'";
 $rs = query( $sql );
 $logerrornum = $rs['num'];

 
 $t_job = $TIME - months2secs( $CN_KEEPLOGS_JOBRUN ? $CN_KEEPLOGS_JOBRUN : $CN_KEEPLOGS );
 $sql = "DELETE FROM jobrun WHERE starttime < '".sqlf_escaped($t_job)."' AND starttime > 1000";
 $rs = query( $sql );
 $jobrunnum = $rs['num'];

 logcmd(W_PURGELOGS,$T_LOGACTION,0,0,"(cmd:$t_cmd,$logcmdnum/err:$t_err,$logerrornum/jobrun:$t_job,$jobrunnum)" );
} else if($cmd == "purgemessages") {
 if( $KEEP_INBOX_MESSAGES < 1 ) halt(7, "KEEP_INBOX_MESSAGES is not defined or too small. $KEEP_INBOX_MESSAGES" );
 $t = $TIME - months2secs( $KEEP_INBOX_MESSAGES );
 $sql = "DELETE FROM msg WHERE timestamp < '".sqlf_escaped($t)."'";
 $rs = query( $sql );
 logcmd(W_PURGEMESSAGES,$T_INBOX_MSG,0,0,"$t (".$rs['num'].")" );
} else if($cmd == "publish") {
 

 node_class("codeparser");
 
 $javaParser =& CodeParser::getJavaParser();

 
 $javaParser->getPublishInfo();
 $running = ($JAVAPARSER_RETURN["params"]["Running"][0] == "true");

 if ($running) {
 
 echo "publish process is already running... rejoining\n";
 } else {
 
 $code = $javaParser->startPublish(); 
 }

 
 $running = true;
 $error = false;
 while ($running) {
 
 query("SELECT 1");
 if ($javaParser->getPublishInfo() === false) {
 
 $returnCode = -1;
 $running = false;
 $error = true;
 } else {
 $running = ($JAVAPARSER_RETURN["params"]["Running"][0] == "true");
 
 if ($running) {
 sleep(10);
 }
 }
 }

 
 if (!$error) {
 
 $returnCode = $JAVAPARSER_RETURN["params"]["ReturnCode"][0];
 }
 $messages = $JAVAPARSER_RETURN["messages"];

 if( $DEBUG['echo'] ) echo "\n\n";
 
 foreach ($messages as $msg) {
 $level = $msg["level"];
 if ($level == "ERROR") {
 echo $level.": ".$msg["code"]."\n";
 }
 }

 
 $javaParser->resetPublisher();

 taralloldlogs();


 
 if ($returnCode != 0) {
 die(1);
 }
} else if($cmd == 'logcycle') {
 taralloldlogs();
} else if($cmd == 'cmd_node_del') {
 if ($node_ids_string) {
 $node_ids = split(",", $node_ids_string);
 }
 $error = cmd_node_del($node_ids);
 if ($error) {
 die("Error while deleting node.");
 }
}
if( $DEBUG['echo'] ) echo "Done: background job with cmd $cmd ".date('Y-md H:i:s');

function taralloldlogs() {
 global $FILEPATH;

 taroldlogs("$FILEPATH/content/log/", "l_", ".html");
 taroldlogs("$FILEPATH/content/log/", "publishrun_", ".txt");
 taroldlogs("/Node/var/tomcat/logs/", "gentics.log.",".txt");
 taroldlogs("/Node/var/tomcat/logs/", "admin.",".log");
 taroldlogs("/Node/var/tomcat/logs/", "catalina.",".log");
 taroldlogs("/Node/var/tomcat/logs/", "host-manager.",".log");
 taroldlogs("/Node/var/tomcat/logs/", "manager.",".log");
 taroldlogs("/Node/var/tomcat/logs/", "localhost.",".log");
}




function months2secs( $months ) {
 
 return $months * 2628000;
}







function taroldlogs($path, $prefix, $postfix) {
 
 exec("find $path -name \"$prefix*$postfix\" -daystart -mtime +0", $output);
 foreach( $output as $file ) {
 
 unset( $matches );
 preg_match( "/(\d{4}-\d{2})-\d{2}/", $file, $matches );
 $date = $matches[0];
 $month = $matches[1];
 $tarfilebare = "$prefix$date.tar";
 $tarfile = "$tarfilebare.gz";
 $monthtarfile = "$prefix$month.tar";

 
 if(file_exists($path.$monthtarfile)) {
 unset( $monthout );
 exec( "tar -tf $path$monthtarfile | grep $tarfile", $monthout );
 if( count( $monthout ) > 0 ) {
 $tarfile = "$prefix$date_".count( $monthout ).".tar.gz";
 }
 }

 
 $argument = 'c';
 if (file_exists($path.$tarfile)) {
 
 
 $argument = 'r';
 unset( $tmp );
 $cmd = "gunzip -f $path$tarfile 2>&1";
 exec( $cmd, $tmp, $rv );
 if( $rv !== 0 ) {
 echo "Error while zipping files ($rv): Command: $cmd - output: " . join("\n",$tmp) . "\n";
 }
 }
 $cmd = "tar -${argument}f $path$tarfilebare $file 2>&1";
 unset( $tmp );
 exec( $cmd, $tmp, $rv );
 if( $rv === 0 ) {
 unlink( $file );
 } else {
 echo "Error while tar'ing files ($rv): Command: $cmd - output: " . join("\n",$tmp) . "\n";
 }

 
 unset( $tmp );
 $cmd = "gzip $path$tarfilebare 2>&1";
 exec( $cmd, $tmp, $rv );
 if( $rv !== 0 ) {
 echo "Error while zipping files ($rv): Command: $cmd - output: " . join("\n",$tmp) . "\n";
 }
 }

 
 unset( $output );
 exec("find $path -name \"$prefix*.tar.gz\" -daystart -mtime +7", $output);
 foreach( $output as $file ) {
 
 unset( $matches );
 preg_match( "/(\d{4}-\d{2})-\d{2}/", $file, $matches );
 $month = $matches[1];
 $monthtarfile = "$prefix$month.tar";

 $argument = 'r';
 if (!file_exists($path.$monthtarfile)) {
 $argument = 'c';
 }
 $cmd = "tar -${argument}f $path$monthtarfile $file 2>&1";
 unset( $tmp );
 exec( $cmd, $tmp, $rv );
 if( $rv === 0 ) {
 unlink( $file );
 } else {
 echo "Error while tar'ing files ($rv): Command: $cmd - output: " . join("\n",$tmp) . "\n";
 }
 }
}

?>