<?

include("$NODEPATH/modules/system/include/sortorderhelper.inc.php");

GUIFactory::setMainGUI( "main" );

mysession_var_reg("OBJPROP_CATEGORY_EDIT_ID");

if( $argcategory ) $OBJPROP_CATEGORY_EDIT_ID = $argcategory;


load_menu( 455, T_OBJPROP_CATEGORY );


class NameFormatter extends ResultsetFormatter {
 function NameFormatter() {
 }
 function format( $row ) {
 global $OBJPROP_CATEGORY_EDIT_ID;
 $val = $row['name'];
 if( $row['id'] == $OBJPROP_CATEGORY_EDIT_ID )
 return "<b>$val</b>";
 return $val;
 }
}
class IconFormatter extends ResultsetFormatter {
 function format( $row ) {
 global $ICO_OBJPROPADMIN;

 return img( $ICO_OBJPROPADMIN );
 }
}

$listform = new HtmlForm3("objprop_category_list");

 node_class("listcomponent");
 node_class("textcomponent");
 node_class("itemlistcomponent");
 node_class("commandaction");

doMoveCommand('objprop_category', T_OBJPROP_CATEGORY);

$sql = "SELECT min(sortorder) AS min, max(sortorder) AS max from objprop_category";
$rs = query( $sql );
$minsortorder = $rs['arr'][0]['min'];
$maxsortorder = $rs['arr'][0]['max'];
 
if ($listform->isNew()) {

 $main = new ListComponent();
 


 $select = "objprop_category.id, name_id, sortorder, dicuser.value AS name";
 $from = "objprop_category LEFT JOIN dicuser ON objprop_category.name_id = dicuser.output_id AND dicuser.language_id = ".sqlf_tl_num($LANGUAGE);
 
 $ds = new SQLDatasource( "objprop_category_listds", $select, $from, '', '', 'sortorder' );
 $ds->setDBHandle( $DB );
 $ds->setSearchable( false );

 $ds->addColumn( 'icon', '', false, false );
 $ds->addFormatter( 'icon', new IconFormatter() );

 $ds->addColumn( "lnkname", i18n( "Category Name" ), true, false );

 $ds->addColumn( 'sortorder', i18n( "Order"), false, false );

 $ds->addFormatter( 'sortorder', new SortOrderFormatter() );

 $ds->makeLink( 'lnkname', 'name', "do=$DO", 'list', 'argcategory', 'id' );

 $ds->addFormatter( 'name', new NameFormatter() );

 $ds->addAction( new CommandAction( $ICO_DELETE, 'del', i18n( 'delete'), 'deleteCategory' ) );
 
 $list = new ItemList3("objprop_category_list", $ds );
 $list->setMaxListItems(50);
 $list->setShowInfo( true );

 $main->setComponent('somelist', new ItemListComponent( '', $list ) );

 $listform->setHeader( i18n( 'Object Property Categories' ), $ICO_OBJPROP );
 $listform->addComponent( 'main', $main );
} else {
 $myitemlistcomp = & $listform->resolveComponent( 'main.somelist' );
 $itemlist3 = & $myitemlistcomp->getList();
 $dsn = & $itemlist3->getDatasource();
 $dsn->setDBHandle( $DB );
}

function deleteCategory( $id ) {
 global $T_FOLDER, $T_PAGE, $T_IMAGE, $T_TEMPLATE, $T_FILE, $DIC;
 $sql = "SELECT objtag.obj_type AS type,COUNT(objprop.id) AS objprop_count FROM objprop LEFT JOIN objtag ON objtag.id = objprop.objtag_id WHERE category_id = '".sqlf_escaped($id)."' group by objtag.obj_type";
 $rs = query( $sql );
 if( $rs['num'] > 0 ) {
 global $JS;
 $c = 0;
 $categories = '';
 foreach( $rs['arr'] as $row ) {
 $c += $row['objprop_count'];
 if( $categories != '' ) $categories .= ', ';
 switch( $row['type'] ) {
 case $T_FOLDER: $categories .= i18n('402.folder'); break;
 case $T_TEMPLATE: $categories .= i18n("Templates"); break;
 case $T_PAGE: $categories .= i18n('pages'); break;
 case $T_IMAGE: $categories .= i18n('images'); break;
 case $T_FILE: $categories .= i18n("Files"); break;
 }
 }
 $JS .= 'alert("'.i18n('Category is still used for {0} Object Properties.',NULL,array( $c, $categories ) ) . '");';
 return;
 }
 $sql = "DELETE FROM objprop_category WHERE id = '".sqlf_escaped($id)."'";
 query( $sql );
}

function saveAction( &$form ) {
 global $OBJPROP_CATEGORY_EDIT_ID, $maxsortorder;

 $fcatname = $form->resolveComponent( 'main.categoryname' );
 $categoryname = $fcatname->getText();
 if( $OBJPROP_CATEGORY_EDIT_ID == 'new' ) {
 $sql = "SELECT MAX(sortorder) AS max FROM objprop_category";
 $rs = query( $sql );
 $sortorder = $rs['arr'][0]['max'] + 1;
 $maxsortorder = $sortorder;
 $name_id = word( $categoryname, 6 );
 $sql = "INSERT INTO objprop_category (name_id,sortorder) values ('".sqlf_escaped($name_id)."', '".sqlf_escaped($sortorder)."')";
 $rs = query( $sql );
 $OBJPROP_CATEGORY_EDIT_ID = $rs['iid'];
 } else {
 $sql = "SELECT name_id FROM objprop_category WHERE id = '".sqlf_escaped($OBJPROP_CATEGORY_EDIT_ID)."'";
 $rs = query( $sql );
 $old_name_id = $rs['arr'][0]['name_id'];
 if( !$old_name_id ) {
 $name_id = word( $categoryname, 6 );
 $sql = "UPDATE objprop_category SET name_id = '".sqlf_escaped($name_id)."' WHERE id = '" . sqlf_escaped($OBJPROP_CATEGORY_EDIT_ID) . "'";
 query( $sql );

 
 $javaParser =& CodeParser::getJavaParser();
 $javaParser->clearCache(T_OBJPROP_CATEGORY, $OBJPROP_CATEGORY_EDIT_ID);
 } else {
 word( $categoryname, 6, $old_name_id );
 }
 }
 cancelAction( $form );
}

function cancelAction( &$form ) {
 global $OBJPROP_CATEGORY_EDIT_ID;
 $OBJPROP_CATEGORY_EDIT_ID = false;
}

if( $OBJPROP_CATEGORY_EDIT_ID ) {
 $edit_form = new HtmlForm3("objprop_category_list_edit");

 if( $edit_form->isNew() ) {
 $editmain = new ListComponent();

 if( $OBJPROP_CATEGORY_EDIT_ID != 'new' ) {
 $sql = "SELECT name_id,dicuser.value AS name FROM objprop_category LEFT JOIN dicuser ON objprop_category.name_id = dicuser.output_id AND dicuser.language_id = ".sqlf_tl_num($LANGUAGE)." WHERE objprop_category.id = '".sqlf_escaped($OBJPROP_CATEGORY_EDIT_ID)."'";
 $rs = query( $sql );
 $categoryname = $rs["arr"][0]["name"];
 }
 
 $name = new TextComponent( 'Name', true, $categoryname );
 $name->setOptional( false );
 $name->setRegex( '.+', i18n( "Please Enter a Name" ) );

 $editmain->setComponent( 'categoryname', $name );

 $edit_form->addComponent( 'main', $editmain );

 $edit_form->addButton( 'save', new Button( i18n( "OK" ) ), new SimpleFormAction( "saveAction" ) );
 $edit_form->addButton( 'cancel', new Button( i18n( "Cancel" ), false ), new SimpleFormAction( "cancelAction" ) );

 $edit_form->setHeader( i18n('Edit Category'), $ICO_OBJPROP );
 }
}

?>
