<?


function user_removecheck($user_id,$group_id,$error = 0, $force = false) {
 global $USER_ID, $ERROR, $DIC;
 
 $perm = perm_usergroup($USER_ID,$group_id,11);
 if ($perm) {
 $sql = "SELECT usergroup_id FROM user_group WHERE user_id = ".sqlf_tl_num($user_id)." and usergroup_id != ".sqlf_tl_num($group_id);
 $rs = query($sql,1);
 
 
 if ($rs["num"] > 0 || $force) $res = true; 
 else {
 $res = false; 
 if ($error == 0) $ERROR = i18n('the_user_must_be_a_member'); elseif ($error == 1) $ERROR = i18n('one_of_the_groups_selected_for_deletion_is_the_last_group_a_user_exists_in_an_therefore_cant_be_deleted._please_assign_this_user_to_another_group_first');
 }
 } else { 
 $res = false; 
 if ($error == 0) $ERROR = i18n('818.the_user_could_not_be'); elseif ($error == 1) $ERROR = i18n('1125.a_group_could_not_be');
 }

 return $res;
}


function user_checklist($usergroups,$admingroups) {

 
 $glist = array();
 $c = count($usergroups);
 for ($i = 0; $i < $c; $i++) {
 if (!in_array($usergroups[$i]["id"],$admingroups)) {
 $mid = $usergroups[$i]["mother"];
 
 if ($mid == 0) return 0;
 
 if (!in_array($mid,$admingroups)) $glist[] = $mid;
 }
 }
 
 
 while (($c = count($glist)) > 0) {

 
 $sql = "SELECT DISTINCT mother FROM usergroup WHERE ";
 for ($i = 0; $i < $c; $i++) {
 $sql .= "id = ".sqlf_tl_num($glist[$i])." OR ";
 }

 $sql .= "1=2";
 $rs = query($sql);
 $glist = array();

 
 for ($i = 0; $i < $rs["num"]; $i++) {
 $mid = $rs["arr"][$i]["mother"];
 if (!in_array($mid,$admingroups)) $glist[] = $mid;
 if ($mid == 0) return 0;
 }
 }

 
 return 1;
}



function user_check($admin_id,$user_id) {

 
 if ($admin_id == $user_id) {
 return 1;
 }

 if (!$admin_id) halt(7,"user_check: No SU-User_ID.");
 if (!$user_id) halt(7,"user_check: No User_ID.");

 

$sql = "SELECT user_group.user_id, user_group.usergroup_id,usergroup.mother,usergroup.id FROM user_group LEFT JOIN usergroup ON usergroup.id = user_group.usergroup_id WHERE user_group.user_id = ".sqlf_tl_num($user_id);
 $rs = query($sql);

 $usergroups = array();
 $admingroups = user_getfull_list($admin_id,1);
 
 

 
 for ($i = 0; $i < $rs["num"]; $i++) {
 $r = $rs["arr"][$i];
 if ($r["user_id"] == $user_id) {
 $arr["id"] = $r["usergroup_id"];
 $arr["mother"] = $r["mother"];
 $usergroups[] = $arr;
 }
 










 }

 $res = user_checklist($usergroups,$admingroups);
 return $res;
}


function u_findroots($root_id,$group_id,&$visited,&$tvisit,&$rootlist) {
 
 $sql = "SELECT mother FROM usergroup WHERE id = ".sqlf_tl_num($group_id);
 $rs = query($sql,true);

 $id = $rs["arr"][0]["mother"];
 
 
 if ($id == 0) { $rootlist[] = $root_id; $tvisit = array(); return; }
 
 if (in_array($id,$visited)) {
 
 while(list($key,$val) = each($tvisit)) {
 $visited[] = $val;
 }
 $tvisit = array();
 return;
 }

 
 $tvisit[] = $id;

 u_findroots($root_id,$id,$visited,$tvisit,$rootlist);

}


$USER_ROOTS = array();

function group_getmothergroups($group_id, $all_groups = Array()) {
 $all_groups[$group_id] = true;
 $sql = "SELECT mother FROM usergroup WHERE id = ".sqlf_tl_num($group_id);
 $rs = query($sql,true);
 $group = $rs["arr"][0];
 while ($group["mother"] && !$all_groups[$group["mother"]]) {
 $all_groups[$group["mother"]] = true;
 $sql = "SELECT mother FROM usergroup WHERE id = ".sqlf_tl_num($group["mother"]);
 $rs = query($sql, true);
 $group = $rs["arr"][0];
 }
 return $all_groups;
}

function group_getmother($group_id) {
 $sql = "SELECT mother FROM usergroup WHERE id = ".sqlf_tl_num($group_id);
 $rs = query($sql);
 if ($rs["num"] > 0) {
 return $rs["arr"][0]["mother"];
 } else {
 return 0;
 }
}


function group_getallusers($group_id) {
 if (is_array($group_id)) {
 $group_id = implode(',',$group_id);
 }

 $sql = 'SELECT DISTINCT user_id FROM user_group WHERE usergroup_id in ('.sqlf_value_list($group_id).')';
 $rs = query($sql);

 $ret = reduce_array($rs["arr"],"user_id","user_id");
 return $ret;
}

function user_getmothergroups($user_id) {
 static $CACHE=array();
 if ( isset( $CACHE[$user_id] ) ) return $CACHE[$user_id];
 $sql = "SELECT usergroup_id FROM user_group WHERE user_id = ".sqlf_tl_num($user_id);
 $rs = query($sql, 1);
 
 $res = array();

 if ($rs["arr"]) {
 while (list($key,$val) = each($rs["arr"])) {
 $res = group_getmothergroups($val["usergroup_id"],$res);
 }
 }
 $CACHE[$user_id] = $res;
 return $res;
}


function user_findroots($user_id,$editonly=0) {
 global $T_GROUPADMIN, $USER_ROOTS;
 
 

 if (is_array($USER_ROOTS[$user_id][$editonly])) {
 $rootsfound = $USER_ROOTS[$user_id][$editonly];
 } else {
 $roots = array();
 $rootsfound = array();
 $visited = array();
 $tvisit = array();

 
 $sql = "SELECT * FROM user_group WHERE user_id = ".sqlf_tl_num($user_id);
 $rs = query($sql);

 for ($i = 0; $i < $rs["num"]; $i++) {
 
 if ($editonly != 0) $perm = perm_usergroup($user_id,$rs["arr"][$i]["usergroup_id"]);


 if ($editonly == 0 || $perm[12] == 1) $roots[] = $rs["arr"][$i]["usergroup_id"];
 }
 
 $visited = $roots;
 
 for ($i = 0; $i < count($roots); $i++) {
 u_findroots($roots[$i],$roots[$i],$visited,$tvisit,$rootsfound);
 }
 
 $USER_ROOTS[$user_id][$editonly] = $rootsfound;
 }

 return $rootsfound;
}


function user_getrootsql($user_id,$editonly=0,$nameofrow = "id") {
 
 if (!$user_id) halt(7,"user_getrootsql: No User_id");

 $rs = user_findroots($user_id,$editonly);

 $sql = "(";
 for ($i = 0; $i < count($rs); $i++) {
 $sql .= "$nameofrow = ".$rs[$i]." OR ";
 }

 
 
 $sql .= "1 = 2)";

 return $sql;
}


function user_walktree($user_id,$group_id,&$grouplist,$eo) {
 global $T_GROUPADMIN;

 if (!in_array($group_id,$grouplist)) {
 
 
 $perm = perm_usergroup($user_id,$group_id);



 if ($eo == 0 || $perm[12] == 1) {

 
 $roots = user_findroots($user_id);
 if (!in_array($group_id,$roots) || $eo == 0) $grouplist[] = $group_id;

 $sql = "SELECT id FROM usergroup WHERE mother = ".sqlf_tl_num($group_id);
 $rs = query($sql,1);

 for ($i = 0; $i < $rs["num"]; $i++) {
 user_walktree($user_id,$rs["arr"][$i]["id"],$grouplist,$eo);
 }
 }
 }
}



function user_findgroups($user_id,$group_id,$editonly=0) {

 if (!$user_id) halt(7,"user_findgroups: No user_id");
 if (!$group_id) halt(7,"user_findgroups: No group_id");

 $glist = array();

 user_walktree($user_id,$group_id,$glist,$editonly);

 return $glist;
}



function user_getfull_list($user_id,$editonly=0) {

 if (!$user_id) halt(7,"user_getfull_list: No User_id");

 $glist = array();

 
 $sql = "SELECT usergroup_id FROM user_group WHERE user_id = ".sqlf_tl_num($user_id);
 $rs = query($sql);

 
 for ($i = 0; $i < $rs["num"]; $i++) {
 user_walktree($user_id,$rs["arr"][$i]["usergroup_id"],$glist,$editonly);
 }

 return $glist;
}

function user_get_visibleuserswithname($userid = 0, $noroots = false) {
 global $ICO_USER, $ICO_GROUP, $FEATURE, $USER_ID;

 $sql = "SELECT firstname, lastname, email, id, LOWER(lastname) AS l_lastname FROM systemuser WHERE active = 1 AND id > 1 AND (";
 $ulist = user_get_visibleusers($userid, $noroots);
 if ($ulist) {
 while (list($key,$val) = each($ulist)) {
 $sql .= "id = ".sqlf_tl_num($val)." OR ";
 }
 }
 $sql .= "1=2) ORDER BY l_lastname";
 
 $rs = query($sql);
 
 
 if ($FEATURE["instantmessages"] && perm($USER_ID, T_INBOX, "", 2)) {
 $o_userlist[-1] = array(
 "id" => -1,
 "lastname" => i18n("all_users"),
 "icon" => "&nbsp;" . img($ICO_GROUP)
 );
 }
 
 if (is_array($rs["arr"])) {
 while (list($key,$val) = each($rs["arr"])) {
 $o_userlist[$key]["id"] = $val["id"];
 $o_userlist[$key]["lastname"] = htmlentities($val["lastname"]." ".$val["firstname"], ENT_COMPAT, 'UTF-8');
 $o_userlist[$key]["icon"] = "&nbsp;".img($ICO_USER);
 $o_userlist[$key]["email"] = $val["email"];
 }
 }
 else $o_userlist = Array();
 reset($o_userlist);
 return $o_userlist;
}

function user_get_visibleusers($userid = 0,$noroots = false) {
 
 global $USER_ID;
 
 if (!$user_id) $user_id = $USER_ID;
 
 if (!$user_id) halt(7,"user_get_visibleusers: no user_id user_id($user_id)");

 if ($user_id == 1) {
 $sql = "SELECT id FROM systemuser WHERE active = 1";
 $rs = query($sql);
 $res = array();
 if ($rs["arr"]) {
 while (list($key,$val) = each($rs["arr"])) {
 $res[] = $val["id"];
 }
 }
 return $res;
 }

 if ($noroots) {
 $rlist = user_findroots($user_id);
 } else $rlist = array();

 
 $glist = user_getfull_list($user_id);

 $sql = "SELECT DISTINCT user_id FROM user_group WHERE ";
 $c = count($glist);
 for ($i = 0; $i < $c; $i++) {
 if (!in_array($glist[$i],$rlist))
 $sql .= "usergroup_id = ".sqlf_tl_num($glist[$i])." OR ";
 }
 $sql .= "1 = 2";
 $rs = query($sql);

 $ulist = array();
 for ($i = 0; $i < $rs["num"]; $i++) {
 $ulist[] = $rs["arr"][$i]["user_id"];
 }

 return $ulist;
}


function user_getuser_list($user_id) {

 if (!$user_id) halt(7,"user_getuser_list: No User_ID");

 
 if ($user_id == 1) {
 $sql = "SELECT id FROM systemuser WHERE active = 1";
 $rs = query($sql);
 $res = array();
 if ($rs["arr"]) {
 while(list($key,$val) = each($rs["arr"])) {
 $res[] = $val["id"];
 }
 }
 return $res;
 }

 
 $glist = user_getfull_list($user_id,1);


 $sql = "SELECT DISTINCT user_id FROM user_group WHERE ";
 $c = count($glist);
 for ($i = 0; $i < $c; $i++) {
 $sql .= " usergroup_id = ".sqlf_tl_num($glist[$i])." OR ";
 }
 
 $sql .= "1 = 2";

 $rs = query($sql);

 $userlist = array();
 $ulist = array();

 
 for ($i = 0; $i < $rs["num"]; $i++) {
 $ulist[] = $rs["arr"][$i]["user_id"];
 }

 $c = count($ulist);
 for ($j = 0; $j < $c; $j++) {
 $uid = $ulist[$j];

 $usergroups = array();
 $alist = array();
 
 
 $sql = "SELECT usergroup.mother,usergroup.id FROM user_group LEFT JOIN usergroup ON user_group.usergroup_id = usergroup.id WHERE user_id = ".sqlf_tl_num($uid);
 $rs = query($sql);

 for ($i = 0; $i < $rs["num"]; $i++) {
 $arr["id"] = $rs["arr"][$i]["id"];
 $arr["mother"] = $rs["arr"][$i]["mother"];
 $usergroups[] = $arr;
 }
 
 
 $is_edit = user_checklist($usergroups,$glist);

 if ($is_edit == 1) $userlist[] = $uid;
 }

 return $userlist;
}





function user_check_password($user_id, $password) {
 $hash = crypt_pw($user_id, $password);
 $rs = query("SELECT id FROM systemuser"
 . " WHERE password = ".sql_str($hash)
 . " AND id = ".sql_num($user_id));
 return (boolean)$rs["num"];
}





function get_users_in_group($group_id) {
 $rs = query('SELECT user_id'
 . ' FROM user_group'
 . ' WHERE usergroup_id = '.sql_num($group_id));
 return is_array($rs['arr']) ? array_column($rs['arr'], 'user_id') : false;
}


