<?php











function mysession_storeUnique( &$var )
{
 global $UNIQUE_ID, $UNIQUE_OBJECT, $DEBUG;
 mysession_var_reg( "UNIQUE_ID" );
 mysession_var_reg( "UNIQUE_OBJECT" );
 if ( !isset( $UNIQUE_ID ) )
 $UNIQUE_ID=0;
 if ( !isset( $UNIQUE_OBJECT ) )
 $UNIQUE_OBJECT = array();

 $id = $UNIQUE_ID;
 $UNIQUE_ID++;
 $UNIQUE_OBJECT[$id] = node_serialize($var);
 if ($DEBUG["echo"] && $DEBUG["unique"] && is_object($var)) echo "Unique: storing ".get_class($var).";$id)<br>";
 return $id;
}






function mysession_createUnique()
{
 global $UNIQUE_ID, $DEBUG;
 mysession_var_reg( "UNIQUE_ID" );
 mysession_var_reg( "UNIQUE_OBJECT" );
 if ( !isset( $UNIQUE_ID ) )
 $UNIQUE_ID=0;
 $id = $UNIQUE_ID;
 $UNIQUE_ID++;
 if ($DEBUG["echo"] && $DEBUG["unique"]) echo "Unique: creating id($id)<br>";
 return $id;
}

function mysession_updateUnique( $key, $var )
{
 $ser = $var;
 global $UNIQUE_OBJECT, $UNIQUE_OBJECT_CLEAR, $DEBUG;
 if ( !is_array($UNIQUE_OBJECT) )
 $UNIQUE_OBJECT = array();
 
 $UNIQUE_OBJECT_CLEAR[$key] = FALSE;
 $UNIQUE_OBJECT[$key] = node_serialize($ser);
 if ($DEBUG["echo"] && $DEBUG["unique"] && is_object($var)) echo "Unique: update ".get_class($var).";$key)<br>";
}







function &mysession_loadUnique( $key , $clear = false )
{
 global $UNIQUE_OBJECT, $DEBUG;
 $rs = NULL;
 if ( is_array($UNIQUE_OBJECT) ) {
 $rs = &node_unserialize( $UNIQUE_OBJECT[$key] );
 if ($DEBUG["echo"] && $DEBUG["unique"]) echo "Unique: load ($key;$clear)<br>";
 if ($clear) mysession_clearUnique( $key );
 }
 return $rs;
}




function mysession_cleanupUnique( $key )
{
 global $UNIQUE_OBJECT, $DEBUG;

 if ( is_array($UNIQUE_OBJECT) ) {
 $val = $UNIQUE_OBJECT[$key];
 if ( isset($val) ) {
 if ($DEBUG["echo"] && $DEBUG["unique"]) echo "Unique: cleanup $key<br>";
 node_var_cleanup($val);
 }
 }

 mysession_clearUnique( $key );
}





function mysession_resetUnique()
{
 global $UNIQUE_ID, $UNIQUE_OBJECT;
 $UNIQUE_ID = 0;
 $UNIQUE_OBJECT = array();
}







function mysession_clearUnique($key ) {
 global $UNIQUE_OBJECT_CLEAR, $DEBUG;
 $UNIQUE_OBJECT_CLEAR[$key] = TRUE;
 if ($DEBUG["echo"] && $DEBUG["unique"]) echo "Unique: clear ($key)<br>";
}

function mysession_unsetClearedUniqueVars() {
 global $UNIQUE_OBJECT_CLEAR, $UNIQUE_OBJECT, $DEBUG;
 if ( !is_array($UNIQUE_OBJECT_CLEAR) ) return;
 foreach ( $UNIQUE_OBJECT_CLEAR as $clearKey=>$isTrue )
 {
 if ( $isTrue )
 {
 if ( $DEBUG["echo"] && $DEBUG["unique"] ) echo "Unique: unset ($clearKey)<br />";
 unset( $UNIQUE_OBJECT[$clearKey] );
 } 
 }
}

?>
