<?
function page_var($id, $folder_id, $contentset_id = FALSE, $channelId = false) {
 global $USER_ID, $FEATURE;

 if($contentset_id === FALSE && $FEATURE['pagevar_all_contentgroups']) {

 $contentset_id = cmd_page_createcs();

 $sql = "SELECT page2.id FROM page page1 INNER JOIN page page2 ON page2.contentset_id = page1.contentset_id WHERE page1.id = '".sqlf_escaped($id)."' AND (page2.contentset_id != 0 || page1.id = page2.id)";
 $rs = query($sql);
 $firstres = NULL;
 foreach($rs['arr'] as $row) {
 $res = page_var($row['id'], $folder_id, $contentset_id, $channelId);
 $firstres || $firstres = $res;
 }

 return $firstres;
 }

 $sql = "SELECT id, name, description, priority, filename, content_id, contentgroup_id, template_id, status
          FROM page
          WHERE id=".sqlf_tl_num($id);
 $rs = query($sql);

 $name = $rs['arr'][0]['name'];
 $desc = $rs['arr'][0]['description'];
 $priority = $rs['arr'][0]['priority'];
 $filename = $rs['arr'][0]['filename'];
 $content_id = $rs['arr'][0]['content_id'];
 $template_id = $rs['arr'][0]['template_id'];
 $contentgroup_id = $rs['arr'][0]['contentgroup_id'];
 $status = $rs['arr'][0]['status'];


 if ( ! perm_can_edit_page($id) && !(perm_can_view_page($id) && $FEATURE["always_allow_page_create_variant"]) ) {
 halt(7, "no ".($FEATURE["always_allow_page_create_variant"]?"view":"edit")." perms to create a variant of page $id in folder $folder_id");
 }

 if ( ! perm_can_create_pages($folder_id, $contentgroup_id) ) {
 halt(7, "no create perms to create a variant of page $id in folder $folder_id");
 }

 global $CONTENT_ID;
 $CONTENT_ID = $content_id;

 $sql = "SELECT node_id, pub_dir FROM folder WHERE id = ".sqlf_tl_num($folder_id);
 $rs = query($sql);
 $node_id = $rs["arr"][0]["node_id"];
 $pub_dir = $rs["arr"][0]["pub_dir"];

 $filename = unique_page_filename($filename, $folder_id, $id);
 if($contentset_id === FALSE) $contentset_id = 0;

 if( $FEATURE['pagevar_all_contentgroups'] ) {
 
 $pagename = $name;
 for($i = 0 ; $i < 99999 ; $i++) {
 $sql = "SELECT id FROM page WHERE name = '".sqlslashes($pagename)."' AND folder_id = '".sqlf_escaped($folder_id)."'";
 $rs = query( $sql );
 if($rs['num'] < 1) break;
 
 if (!$i) $tmp = "";
 else $tmp = " ".($i+1);
 $pagename = i18n( "Variant{0} of page {1}", 0, $tmp, $name );
 }
 $name = $pagename;
 }

 $res = cmd_page_create($name, $desc, $priority, $filename, $template_id, $folder_id, $contentgroup_id, $contentset_id, false, $channelId);

 
 if ($status == 3) {
 page_status($res, $status, $USER_ID);
 }

 return $res;
}

function page_copy($id, $folder_id, $create_copy = false, $pagename = '', $filename = '', $cs_id = 0, $keep_pagename = false, 
 $new_content_id = 0, $new_contentgroup_id = -1, $sync_page_id = 0, $channelId = false) {

 
 
 
 global $T_PAGE, $FEATURE, $W_COPY, $PAGE_COPY_EXCLUDE_OBJPROP, $TIME, $USER_ID;

 
 if ($FEATURE["multichannelling"]) {
 $folder = new CNFolderObject($folder_id);
 $folder_id = $folder->getMasterId();
 }

 if ( !$cs_id ) {
 $cs_id = cmd_page_createcs(); 
 
 if ( $FEATURE['contentgroup3']) {
 
 
 
 $update_syncinfo = array();
 $sql = "SELECT contentset_id, channel_id FROM page WHERE id = ".sqlf_tl_num($id);
 $rs = query($sql);
 if ($rs["arr"][0]["contentset_id"] > 0) {
 
 $sql = "SELECT id, contentset_id FROM page WHERE channel_id = ".sqlf_tl_num($rs['arr'][0]['channel_id'])." AND contentset_id = ".sqlf_tl_num($rs['arr'][0]['contentset_id']);
 $rs = query($sql);
 foreach ( $rs['arr'] as $page ) {
 if ( $page['id'] != $id ) {
 $copy_page_id = page_copy($page['id'], $folder_id, $create_copy, $pagename, $filename, $cs_id, $keep_pagename, 0, -1, 0, $channelId);
 $update_syncinfo[$page['id']] = $copy_page_id;
 }
 }
 }
 }
 }
 

 
 
 $user_abort = ignore_user_abort(true);

 $folder = get_folderinfo($folder_id);

 $sql = "SELECT * FROM page WHERE id = ".sqlf_tl_num($id);
 $rs = query($sql);

 $page = $rs["arr"][0];
 if (!$pagename)
 $pagename = $page["name"];
 if (!$filename)
 $filename = $page["filename"];
 $i = 0;
 
 if ( ! perm_can_view_page($id) ) {
 halt(7, "no view perms to copy page $id");
 }

 $new_cg_id = $new_contentgroup_id == -1 ? $page["contentgroup_id"] : $new_contentgroup_id;

 if ( ! perm_can_create_page_or_translation($folder_id, $new_cg_id) ) {
 halt(7, "no create perms to copy page $id (contentgroup $new_cg_id)"
 . " into folder $folder_id");
 }

 if ( !$keep_pagename )
 {
 if (!$create_copy) {
 if ( $FEATURE["contentgroup3"] ) $moreSql = " AND contentset_id!=".sqlf_tl_num($cs_id);
 else $moreSql = "";
 
 $sql = "SELECT id FROM page WHERE name = '".sqlslashes($pagename)."' AND folder_id = ".sqlf_tl_num($folder_id)." $moreSql";
 $rs = query($sql);
 if ($rs["num"] > 0) {
 ignore_user_abort($user_abort);
 return $rs["arr"][0]["id"];
 }
 } else {
 while ($i == 0 || $rs["num"] > 0) {
 if (!$i) $tmp = "";
 else $tmp = " ".($i+1);
 $name = i18n( "Copy {0} of page {1}", 0, $tmp, $pagename );
 $sql = "SELECT id FROM page WHERE name = '".sqlslashes($name)."' AND folder_id = ".sqlf_tl_num($folder_id);
 $rs = query($sql);
 $i++;
 }
 $pagename = $name;
 }
 }

 $sql = "SELECT node_id, pub_dir FROM folder WHERE id = ".sqlf_tl_num($folder_id);
 $rs = query($sql);
 $node_id = $rs["arr"][0]["node_id"];
 $pub_dir = $rs["arr"][0]["pub_dir"];

 
 $num = 0;

 if (!$create_copy) {
 if (page_exists($pagename,$filename,$pub_dir,$node_id,$folder_id)) $num = 1;
 }

 
 if ($create_copy || $num > 0) {
 $fnew = unique_page_filename($filename, $folder_id, $id);
 } else {
 $fnew = $filename;
 }

 $new_status = $page["status"];

 
 if ($new_status == 1 || $new_status == 2 || $new_status == 4) {
 $new_status = 0;
 }

 if (!$sync_page_id) {
 $sync_page_id = 0;
 }

 
 
 if ($FEATURE["multichannelling"] && $channelId === false) {
 $channelId = $folder["channel_id"];
 } else if (!$FEATURE["multichannelling"]) {
 $channelId = 0;
 }

 
 if ($channelId != 0) {
 $channel = get_nodeinfo($channelId);
 if (!$channel["master_id"]) {
 $channelId = 0;
 }
 }

 
 $channelsetId = createChannelsetId();

 $sql = "INSERT INTO page (name, description, filename, priority, status, time_start, time_end, time_mon, time_tue, time_wed, time_thu, time_fri, time_sat, time_sun, content_id, template_id, folder_id, creator, cdate, editor, edate, pdate, publisher, time_pub, contentgroup_id, contentset_id, sync_page_id, channel_id, channelset_id) 
VALUES (
'".sqlslashes($pagename)."', '".sqlslashes($page["description"])."', '".sqlslashes($fnew)."', '".sqlf_escaped($page["priority"])."', '".sqlf_escaped($new_status)."', '".sqlf_escaped($page["time_start"])."', '".sqlf_escaped($page["time_end"])."', '".sqlf_escaped($page["time_mon"])."', '".sqlf_escaped($page["time_tue"])."', '".sqlf_escaped($page["time_wed"])."', '".sqlf_escaped($page["time_thu"])."', '".sqlf_escaped($page["time_fri"])."', '".sqlf_escaped($page["time_sat"])."', '".sqlf_escaped($page["time_sun"])."', ".($new_content_id ? "'".sqlf_escaped($new_content_id)."'" : "NULL" ) . ", '".sqlf_escaped($page["template_id"])."', '".sqlf_escaped($folder_id)."', '".sqlf_escaped($page["creator"])."', '".sqlf_escaped($page["cdate"])."', '".sqlf_escaped($page["editor"])."', '".sqlf_escaped($page["edate"])."', '".sqlf_escaped($page["pdate"])."', '".sqlf_escaped($page["publisher"])."','".sqlf_escaped($page["time_pub"])."','".sqlf_escaped($new_cg_id)."','".sqlf_escaped($cs_id)."', ".sql_num($sync_page_id).", ".sql_num($channelId).", ".sql_num($channelsetId).")";
 $rs = query($sql);
 $new_page_id = $rs["iid"];
 if (!$new_page_id) halt(7,"page_copy: invalid new_page_id($new_page_id)");

 
 if ($update_syncinfo) {
 $update_syncinfo[$id] = $new_page_id;
 }

 $mother["new"]["page_id"] = $new_page_id;
 $mother["old"]["page_id"] = $id;

 
 if (!$new_content_id) $new_content_id = content_duplicate($page["content_id"], $folder["node_id"], $mother);

 
 if (!$new_content_id) {
 
 query("DELETE FROM page WHERE id = ".sqlf_tl_num($new_page_id));
 halt(7,"page_copy: invalid new_content_id($new_content_id)");
 }

 
 $sql = "UPDATE page SET content_id = ".sqlf_tl_num($new_content_id)." WHERE id = ".sqlf_tl_num($new_page_id);
 query($sql);

 
 $sql = "SELECT id,name FROM objtag WHERE obj_id = ".sqlf_tl_num($id)." AND obj_type = ".sqlf_tl_num($T_PAGE);
 $rs = query($sql);
 if (is_array($rs["arr"])) {
 while (list($key,$row) = each($rs["arr"])) {
 if(!in_array( $row['name'], $PAGE_COPY_EXCLUDE_OBJPROP )) {
 tag_duplicate($row["id"], "obj", $new_page_id);
 }
 }
 }

 
 node_class("cnpageobject");
 $pageobject = new CNPageObject($new_page_id);
 $pageobject->createVersion($TIME, $USER_ID);

 
 if ($update_syncinfo) {
 while (list($old_id, $new_id) = each($update_syncinfo)) {
 $oldpageobject = new CNPageObject($old_id);
 $sync_page_id = $oldpageobject->getFieldValue("sync_page_id");
 if ($sync_page_id) {
 $new_sync_page_id = $update_syncinfo[$sync_page_id];

 if ($new_sync_page_id) {
 
 $sync_timestamp = $oldpageobject->getFieldValue("sync_timestamp");
 $new_sync_timestamp = 0;
 if ($sync_timestamp) {
 
 $sync_pageobject = new CNPageObject($sync_page_id);
 $versions = $sync_pageobject->getProperty("versions");
 if ($versions && $versions->size() >= 1) {
 $lastversion = $versions->get($versions->size() - 1);
 $lastversiondate = $lastversion->getProperty("date");
 if ($lastversiondate->getTimestamp() == $sync_timestamp) {
 
 $new_sync_timestamp = $TIME;
 }
 }
 }
 
 query("UPDATE page SET sync_page_id = ".sqlf_tl_num($new_sync_page_id).", sync_timestamp = ".sqlf_tl_num($new_sync_timestamp)." WHERE id = ".sqlf_tl_num($new_id));
 }
 }
 }
 }

 logcmd($W_COPY, $T_PAGE, $page["id"], $folder_id, "page_copy" );
 trigger_event("onpagecopy",array("page_id"=>$id,"new_page_id"=>$new_page_id,"to_folder_id"=>$folder_id));

 
 if ($FEATURE["javaparser"]) {
 $javaParser =& CodeParser::getJavaParser();
 $javaParser->clearCache(T_FOLDER, $folder_id);
 }

 
 
 
 

 ignore_user_abort($user_abort);
 return $new_page_id;
}


function content_duplicate($id, $node_id, $mother = Array(), $type = "content") {

 global $FEATURE;

 $tplgroup_id = 0;
 if ($type == "content") {
 $sql = "SELECT id, node_id, creator, cdate, editor, edate FROM content WHERE id = ".sqlf_tl_num($id);
 $rs = query($sql);
 $content = $rs["arr"][0];
 if (!$node_id) $node_id = $content["node_id"];
 $sql = "INSERT INTO content (node_id, creator, cdate, editor, edate) VALUES
	(".sqlf_tl_num($node_id).", ".sqlf_tl_num($content["creator"]).", ".sqlf_tl_num($content["cdate"])." , ".sqlf_tl_num($content["editor"]).", ".sqlf_tl_num($content["edate"]).")";
 $rs = query($sql);
 $new_content_id = $rs["iid"];

 if (!$new_content_id) halt(7,"content_duplicate: invalid new_content_id($new_content_id)");
 } else if ($type == "template") {
 $sql = "SELECT folder_id, templategroup_id FROM template WHERE id = ".sqlf_tl_num($mother);
 $rs = query($sql);
 if (!$rs["num"]) halt(7, "content_duplicate: template_id($mother) does not exist.");
 $tplgroup_id = $rs["arr"][0]["templategroup_id"];
 if (!$node_id) {
 $folder = get_folderinfo($rs["arr"][0]["folder_id"]);
 $node_id = $folder["node_id"];
 }
 if (!$mother) halt(7, "content_duplicate: no mother template ($mother).");
 $new_content_id = $mother;
 } else {
 halt(7, "content_duplicate: unknown type($type)");
 }

 
 $sql = "SELECT id FROM ".sqlf_field($type)."tag WHERE ".sqlf_field($type)."_id = ".sqlf_tl_num($id);
 $rs = query($sql);
 if (is_array($rs["arr"])) {
 while (list($key,$row) = each($rs["arr"])) {
 $tag_id = $row["id"];
 $new_tag_id = tag_duplicate($tag_id, $type, $new_content_id, "", $tplgroup_id, 0, false, true);

 if (!$new_tag_id) {
 continue;
 }

 
 if ($FEATURE["table_old"] && $type == "content") {
 $sql = "SELECT part_id, th, td_f_even, td_f_odd, th_f, td_type, th_type, table_f FROM contenttable
WHERE contenttag_id = ".sqlf_tl_num($tag_id);
 $rs_tmp = query($sql);
 if ($rs_tmp["num"] == 1) {
 $rs_tmp = $rs_tmp["arr"][0];
 $sql = "INSERT INTO contenttable (contenttag_id, part_id, th, td_f_even, td_f_odd, th_f, td_type, th_type, table_f) VALUES
(".sqlf_tl_num($new_tag_id).", ".sqlf_tl_num($rs_tmp["part_id"]).", '".sqlslashes($rs_tmp["th"])."', '".sqlslashes($rs_tmp["td_f_even"])."', '".sqlslashes($rs_tmp["td_f_odd"])."', '".sqlslashes($rs_tmp["th_f"])."', '".sqlslashes($rs_tmp["td_type"])."', '".sqlslashes($rs_tmp["th_type"])."', '".sqlslashes($rs_tmp["table_f"])."')";
 query($sql);
 }
 }

 
 if ($type == "content") {
 
 $sql = "SELECT value.id FROM part, value 
	WHERE part.id = value.part_id AND part.type_id = 4 
	AND value.".sqlf_table($type)."tag_id = ".sqlf_tl_num($new_tag_id)." 
	AND value.value_ref = ".sqlf_tl_num($mother["old"]["page_id"]);
 $rs_tmp = query($sql);
 if ($rs_tmp["num"] > 0) {
 while(list($key,$row) = each($rs_tmp["arr"])) {
 cmd_update_value( "", $mother["new"]["page_id"], false, "content", FALSE, $row["id"] );
 }
 }

 
 $sql = "SELECT value.id FROM part, value
	WHERE part.id = value.part_id AND part.type_id = 11
	AND value.contenttag_id = ".sqlf_tl_num($new_tag_id)."
	AND value.value_ref = ".sqlf_tl_num($tag_id);
 $rs_tmp = query($sql);
 if($rs_tmp["num"] > 0) {
 while (list($key,$row) = each($rs_tmp["arr"])) {
 cmd_update_value( "", $new_tag_id, false, "content", false, $row["id"] );
 }
 }
 }
 }
 }

 return $new_content_id;

}






function tag_duplicate($id, $type, $new_mother = 0, $new_name = "", $tplgroup_id = 0, $new_intag = 0, $change_pagestatus = true, $ignore_existing = false) {
 set_time_limit(0);

 if (!$id || ($type != "content" && $type != "obj" && $type != "template")) halt(7,"tag_duplicate: invalid id($id) or type($type)");

 if ($type == "content" || $type == "template") {
 
 $sqlpart = ($type == "template")?", pub":"";
 $sql = "SELECT id, ".sqlf_field($type)."_id, construct_id, name, enabled $sqlpart FROM ".sqlf_field($type)."tag WHERE id = ".sqlf_tl_num($id);
 $rs = query($sql);
 $tag = $rs["arr"][0];
 
 
 if (!$new_name) $new_name = $tag["name"];
 if (!$new_mother) $new_mother = $tag[$type."_id"];
 
 
 $sql = "SELECT id FROM ".sqlf_field($type)."tag WHERE name = \"".sqlslashes($new_name)."\" AND ".sqlf_field($type)."_id = ".sqlf_tl_num($new_mother);
 $rs = query($sql);
 if ($rs["num"] > 0 && !$ignore_existing) halt(7,"tag_duplicate: tag already exists. new_name($new_name) new_mother($new_mother) type($type), id($id)");
 else if ($rs["num"] > 0) {
 return;
 }
 
 
 $sqlinsert = ($type == "template")?",pub,templategroup_id":"";
 $sqlvalue = ($type == "template")?",".sqlf_tl_num($tag["pub"]).",".sqlf_tl_num((int)$tplgroup_id):"";
 $sql = "INSERT INTO ".sqlf_field($type)."tag (".sqlf_field($type)."_id, construct_id, name, enabled $sqlinsert) VALUES (".sqlf_tl_num($new_mother).", ".sqlf_tl_num($tag["construct_id"]).", '".sqlslashes($new_name)."', ".sqlf_tl_num($tag["enabled"])." $sqlvalue)";
 $rs = query($sql);
 $new_tag_id = $rs["iid"];
 
 } else if ($type == "obj") {
 
 $sql = "SELECT id, obj_id, obj_type, construct_id, name, enabled, intag FROM objtag WHERE id = ".sqlf_tl_num($id);
 $rs = query($sql);
 $tag = $rs["arr"][0];

 
 if (!$new_name) $new_name = $tag["name"];
 if (!$new_mother) $new_mother = $tag["obj_id"];

 
 $sql = "SELECT id FROM objtag WHERE obj_id = ".sqlf_tl_num($new_mother)." AND name = \"".sqlslashes($new_name)."\" AND obj_type = ".sqlf_tl_num($tag["obj_type"]);
 $rs = query($sql);
 if ($rs["num"] > 0 && !$ignore_existing) halt(7,"tag_duplicate: tag already exists. new_name($new_name) new_mother($new_mother) type($type), id($id)");
 else if ($rs["num"] > 0) {
 return;
 }

 
 $sql = "INSERT INTO objtag (obj_id, obj_type, construct_id, name, enabled, intag) VALUES  
(".sqlf_tl_num($new_mother).", ".sqlf_tl_num($tag["obj_type"]).", ".sqlf_tl_num($tag["construct_id"]).", '".sqlslashes($new_name)."', ".sqlf_tl_num($tag["enabled"]).", ".sqlf_tl_num($new_intag).")";
 $rs = query($sql);
 $new_tag_id = $rs["iid"];

 
 $sql = "SELECT * FROM objtag WHERE intag = ".sqlf_tl_num($id);
 $rs = query($sql);
 while (list($key,$row) = each($rs["arr"])) {
 
 
 tag_duplicate( $row['id'], $type, $new_mother, '', $tplgroup_id, $new_tag_id, $change_pagestatus, true );
 }
 }

 if (!$new_tag_id) halt(7,"tag_duplicate: invalid new_tag_id($new_tag_id)");

 
 $sql = "SELECT value_text, value_ref, info, part_id FROM value WHERE value.".sqlf_field($type)."tag_id = ".sqlf_tl_num($id);
 $rs = query($sql);
 if ($rs["num"] > 0) {
 while (list($key,$row) = each($rs["arr"])) {
 
 
 
 
 
 
 
 $no_cache_clear = true;
 cmd_insert_value($row["value_text"], $row["value_ref"], $row["info"], $type, $new_tag_id, 
 $row["part_id"], false, false, $change_pagestatus, $no_cache_clear );
 }
 }


 
 $sql = "SELECT id, ".sqlf_field($type)."tag_id, o_type, is_folder, orderkind, orderway, max_obj, recursion FROM ds 
WHERE ".sqlf_field($type)."tag_id = ".sqlf_tl_num($id);
 $rs_ds = query($sql);
 if ($rs_ds["num"] > 0) {
 while (list($key,$row) = each($rs_ds["arr"])) {
 $sql = "INSERT INTO ds (".sqlf_field($type)."tag_id, o_type, is_folder, orderkind, orderway, max_obj, recursion) VALUES
(".sqlf_tl_num($new_tag_id).", ".sqlf_tl_num($row["o_type"]).", ".sqlf_tl_num($row["is_folder"]).", ".sqlf_tl_num($row["orderkind"]).", ".sqlf_tl_num($row["orderway"]).", ".sqlf_tl_num($row["max_obj"]).", ".sqlf_tl_num($row["recursion"]).")";
 $rsi = query($sql);
 $sql = "SELECT o_id, obj_order, adate, auser FROM ds_obj WHERE ".sqlf_field($type)."tag_id = ".sqlf_tl_num($id);
 $rs_dsobj = query($sql);
 if ($rs_dsobj["num"] > 0) {
 while (list($key,$row2) = each($rs_dsobj["arr"])) {
 $sql = "INSERT INTO ds_obj (".sqlf_field($type)."tag_id, ds_id, o_id, obj_order, adate, auser) VALUES
(".sqlf_tl_num($new_tag_id).", ".sqlf_tl_num($row["id"]).", ".sqlf_tl_num($row2["o_id"]).", ".sqlf_tl_num($row2["obj_order"]).", ".sqlf_tl_num($row2["adate"]).", ".sqlf_tl_num($row2["auser"]).")";
 query($sql);
 }
 }
 }
 }


 return $new_tag_id;
}


function tag_copy($source_id,$source_type,$target_id,$target_type,$change_pagestatus = true) {

$modcount = 0;
if ($source_type == "template" && $target_type == "content")
$sql = "SELECT templatetag.id, templatetag.name, templatetag.enabled, templatetag.construct_id FROM templatetag 
WHERE template_id = ".sqlf_tl_num($source_id)." AND pub = 1";
else halt(7,"tag_copy: invalid source_type($source_type) and target_type($target_type)");
$rs_tag = query($sql);
while ($rs_tag["arr"] && list($n,$row_tag) = each($rs_tag["arr"])) {

 $source_tag_id = $row_tag["id"];
 $tag_name = sqlslashes($row_tag["name"]);
 $tag_enabled = $row_tag["enabled"];
 $tag_cid = $row_tag["construct_id"];

 $sql = "SELECT id FROM contenttag WHERE content_id = ".sqlf_tl_num($target_id)." AND name = '".sqlf_escaped($tag_name)."'";
 $rs = query($sql);

 
 if (!$rs["arr"]) {

 
 $modcount++;
 if ($target_type == "content")
 $sql = "INSERT INTO contenttag (content_id,construct_id,name,enabled)
VALUES (".sqlf_tl_num($target_id).",".sqlf_tl_num($tag_cid).",'".sqlf_escaped($tag_name)."',".sqlf_tl_num($tag_enabled).")";
 
 $rs = query($sql);
 $target_tag_id = $rs["iid"];
 
 
 if ($source_type == "template")
 $sql = "SELECT value.part_id, value.info, value.value_text, value.value_ref FROM value
WHERE value.templatetag_id = ".sqlf_tl_num($source_tag_id)." AND value.static = 0";
 
 $rs_val = query($sql);
 while ($rs_val["arr"] && list($n,$row_val) = each($rs_val["arr"])) {
 
 $val_pid = $row_val["part_id"];
 $val_info = $row_val["info"];
 $val_vt = $row_val["value_text"];
 $val_vr = $row_val["value_ref"];
 
 
 if ($target_type == "content") {
 $modcount++;
 cmd_insert_value( $val_vt, $val_vr, $val_info, "content", $target_tag_id, $val_pid, false, false, $change_pagestatus );
 }
 else halt(7,"copy_tags: invalid target_type($target_type)");
 }

 } else $target_tag_id = $rs["arr"][0]["id"];

 
 $sql = "SELECT part_id,th,td_f_even,td_f_odd,th_f,td_type,th_type,table_f 
AS c FROM contenttable WHERE templatetag_id = ".sqlf_tl_num($source_tag_id);
 $rs_a = query($sql);
 if ($rs_a["num"] > 0) {
 $sql = "SELECT count(*) AS c FROM contenttable, contenttag WHERE contenttable.contenttag_id = contenttag.id
AND contenttag.name = '".sqlf_escaped($tag_name)."' AND contenttag.content_id = ".sqlf_tl_num($target_id);
 $rs_b = query($sql);
 if ($rs_b["arr"][0]["c"] == 0) {
 $r = $rs_a["arr"][0];
 $part_id = $r["part_id"];
 $th = $r["th"];
 $td_f_even = sqlslashes($r["td_f_even"]);
 $td_f_odd = sqlslashes($r["td_f_odd"]);
 $th_f = sqlslashes($r["th_f"]);
 $td_type = $r["td_type"];
 $th_type = $r["th_type"];
 $table_f = sqlslashes($r["table_f"]);
 $modcount++;
 $sql = "INSERT INTO contenttable (contenttag_id,part_id,th,td_f_even,td_f_odd,th_f,td_type,th_type,table_f)
VALUES (".sqlf_tl_num($target_tag_id).",".sqlf_tl_num($part_id).",".sqlf_tl_num($th).",'".sqlf_escaped($td_f_even)."','".sqlf_escaped($td_f_odd)."','".sqlf_escaped($th_f)."',".sqlf_tl_num($td_type).",".sqlf_tl_num($th_type).",'".sqlf_escaped($table_f)."')";
 query($sql);
 }
 }

 
 $sql = "SELECT count(ds.id) AS c FROM ds, contenttag WHERE ds.contenttag_id = contenttag.id
AND contenttag.name = '".sqlf_escaped($tag_name)."' AND contenttag.content_id = ".sqlf_tl_num($target_id);
 $rs = query($sql);

 
 if ($rs["arr"][0]["c"] == 0) {
 $sql = "SELECT id, is_folder, orderkind, orderway, max_obj, recursion, o_type FROM ds
WHERE templatetag_id = ".sqlf_tl_num($source_tag_id);
 $rs_b = query($sql);
 $ds_row = $rs_b["arr"][0];
 if ($rs_b["num"] > 0) {
 $sql = "SELECT ds_id, o_id, obj_order FROM ds_obj WHERE templatetag_id = ".sqlf_tl_num($source_tag_id);
 $rs_c = query($sql);
 if ($rs_c["num"] > 0) while (list($key,$row) = each($rs_c["arr"])) {
 $sql = "INSERT INTO ds_obj (ds_id,".sqlf_table($target_type)."tag_id,o_id,obj_order) 
VALUES (".sqlf_tl_num($row["ds_id"]).",".sqlf_tl_num($target_tag_id).",".sqlf_tl_num($row["o_id"]).",".sqlf_tl_num($row["obj_order"]).")";
 query($sql);
 }
 $modcount++;
 $sql = "INSERT INTO ds (".sqlf_table($target_type)."tag_id, is_folder, orderkind, orderway, max_obj, recursion, o_type)
VALUES (".sqlf_tl_num($target_tag_id).",".sqlf_tl_num($ds_row["is_folder"]).",".sqlf_tl_num($ds_row["orderkind"]).",".sqlf_tl_num($ds_row["orderway"]).",".sqlf_tl_num($ds_row["max_obj"]).",".sqlf_tl_num($ds_row["recursion"]).",".sqlf_tl_num($ds_row["o_type"]).")";
 query($sql);
 }
 }

}
 return $modcount;
}

?>
